<!-- manual page source format generated by PolyglotMan v3.0.7, -->
<!-- available via anonymous ftp from ftp.cs.berkeley.edu:/ucb/people/phelps/tcltk/rman.tar.Z -->

<HTML>
<HEAD>
<TITLE>Man page for pscc.1</TITLE>
</HEAD>
<BODY bgcolor=white>
<A HREF="#toc">Table of Contents</A><P>

<H2><A NAME="sect0" HREF="#toc0">Name</A></H2>

<P>
pscc - parallelizing SUIF compiler driver program

<H2><A NAME="sect1" HREF="#toc1"><B>Synopsis</B></A></H2>

<P>
<B>pscc</B> [ <I>options</I> ] files ...

<H2><A NAME="sect2" HREF="#toc2"><B>Description</B></A></H2>

<P>
The <I>pscc</I> program is a version of the <I>scc</I> driver with parallelization
features added. It is a driver for the SUIF
ANSI C and FORTRAN 77 compiler. It behaves much like the
system's <I>cc</I> compiler. SUIF is a multi-pass compiler. The
following chart shows the order in which some of the basic
passes are executed and the filename extensions that <I>pscc</I>
uses for the output of each pass:

<DL>

<DT><I>.c</I> </DT></DT>
<DD>            Fortran-to-C translator
</DD>

<DT><I>.i</I> </DT></DT>
<DD>            C preprocessor
</DD>

<DT><I>.snt</I> </DT></DT>
<DD>          C front end
</DD>

<DT><I>.spd</I> </DT></DT>
<DD>          SUIF cleanup pass
</DD>

<DT><I>.spx</I> </DT></DT>
<DD>          Expander
</DD>

<DT><I>.sfo</I> </DT></DT>
<DD>          Back-end optimizer
</DD>

<DT><I>.s</I> </DT></DT>
<DD>            Code generator (currently only for MIPS
systems)
</DD>

<DT><I>.o</I> </DT></DT>
<DD>            Assembler
</DD>

<DT>(a.out) </DT></DT>
<DD>       Linker
</DD>
</DL>
<P>
The extension of each filename argument determines where
in the compilation process the compiler will start for
that file. For example, files whose names end with <I>.c</I> are
assumed to be C source programs, whereas arguments whose
names end with <I>.s</I> are assumed to be assembler files.
Files with extensions <I>.f</I> and <I>.F</I> are both treated as Fortran
files.

<H2><A NAME="sect3" HREF="#toc3"><B>Options</B></A></H2>

<P>
Options with identical meanings to those in <I>cc</I> are <B>-S</B>, <B>-c</B>,
<B>-I</B>, <B>-D</B>, <B>-U</B>, <B>-o</B>, <B>-L</B>, <B>-G</B>, <B>-l</B>, <B>-w</B>, <B>-E</B> and <B>-M</B>. The following
options are specific to <I>pscc</I>:

<DL>

<DT><B>-B</B><I>dir</I> </DT></DT>
<DD>Look for the compiler binaries in directory <I>dir</I>.
</DD>

<DT><B>-show</B></DT></DT>
<DD>
<B>-v</B>
</DD>

<DT><B>-V</B> </DT></DT>
<DD>    As each pass is executed, print the pass name followed
by the command line to execute it.
</DD>

<DT><B>-k</B> </DT></DT>
<DD>    Don't execute the passes. Useful in conjunction
with <B>-v</B> to see what passes <I>pscc</I> executes with which
flags. For example, to see what passes are run
with the <B>-O</B> flag, run ``pscc -v -k -O foo.c''.
</DD>

<DT><B>-T</B> </DT></DT>
<DD>    Print timing information for each pass as it is
executed.
</DD>

<DT><B>-g</B> </DT></DT>
<DD>    Keep symbolic information for debugging. This
affects only <I>s2c</I> or other back ends. For <I>s2c</I>, it
means putting the original source line numbers in
the output C file.
</DD>

<DT><B>-s2c</B> </DT></DT>
<DD>Use the SUIF-to-C pass in place of the SUIF backend.
This is the default for systems for which
there is no SUIF code generator (at present, everything
except MIPS).
</DD>

<DT><B>-cc</B> <I>compiler</I></DT></DT>
<DD>
Use the specified C compiler to generate code after
running the SUIF-to-C pass. This option is only
meaningful in combination with the <B>-s2c</B> option.
</DD>

<DT><B>-f2c</B></DT></DT>
<DD>
<B>-sf2c</B> Informs relevant passes that source files came from
Fortran. This is the default for filenames with <I>.f</I>
or <I>.F</I> extensions.
</DD>

<DT><B>-.</B><I>suffix</I></DT></DT>
<DD>
Stop the compilation process after files with the
given <I>suffix</I> have been generated (see chart above).
For example, the option ``-.sfo'' stops the compilation
process after optimization, placing output
in files with a suffix ``.sfo''. (The <B>-.s</B> and <B>-.o</B>
options are equivalent to <B>-S</B> and <B>-c</B> respectively.)
</DD>

<DT><B>-keep</B> </DT></DT>
<DD>Save all files generated for each phase, with the
appropriate extensions, in the current directory.
If this flag is repeated, also save temporary files
used within phases when a phase executes more than
one pass, as does the optimization phase.
</DD>

<DT><B>-O</B> </DT></DT>
<DD>    Invoke the SUIF optimizer and register allocator.
If your program does not speed up by at least 50%,
Steve Tjiang will donate a pizza to the charity of
his choice. Really.
</DD>

<DT><B>-O2</B> </DT></DT>
<DD>   Invoke the SUIF optimizer. Run an extra pass of
code motion.
</DD>

<DT><B>-Oivard</B></DT></DT>
<DD>
Find induction variables and perform other optimizations
in the front-end.
</DD>

<DT><B>-Oifs</B> </DT></DT>
<DD>Moves IFs in and then out again.
</DD>

<DT><B>-Oregs</B> Do register allocation.</DT></DT>
<DD>
</DD>

<DT><B>-t</B><I>dir</I> </DT></DT>
<DD>Use directory <I>dir</I> for temporaries. If no <B>-t</B> option
is specified, temporary files are written to the
/tmp directory by default. See also the <B>TMPDIR</B>
environment variable.
</DD>

<DT><B>-multi</B> Produce parallel code using the old SUIF optimizer.</DT></DT>
<DD>
Unlike the <B>-parallel</B> flag, with this option the
SUIF code is turned into old SUIF code and several
passes are run to attempt to increase the information
available for parallelization. The code is
then turned back into new SUIF for parallelization.
This option can be somewhat buggy as the old SUIF
optimizer has some problems.
<B>-parallel</B>
Produce parallel code. Only new SUIF passes are
used for parallelization. This avoids the bugs
from old SUIF that the <B>-multi</B> flag gets in some
cases.    The optimizations used by <B>-multi</B> use
stronger algorithms than those currently implemented
in new SUIF, however, so that option may
give more parallelism when it does work.
<B>-reassoc</B>
Reassociate complex array address calculations such
that it is easier to code motion parts out of the
inner loop. The default is to do so only when
scalar optimization is being performed.
<B>-noreassoc</B>
Don't bother to reassociate array address calculations.
<B>-Target</B> <I>machine</I>
Override the default target architecture to perform
a cross-compilation with target <I>machine.</I> This
option only affects passes that are provided with
SUIF; correct cross-system use of assemblers, linkers,
back-end C compilers, and files include by the
C pre-processor is left up to the user. To be
safe, this option should only be used when compiling
up to the point where the code is converted out
of SUIF into assembly or back-end C code. Likewise,
system include-file compatability is up to
the user, so Fortran should be fine but typical C
code won't go through cpp correctly without additional
measures because the included system header
files will not be those of the target machine.
<B>-option</B> <I>passname</I> <I>flags</I>
Call compilation pass <I>passname</I> with the <I>flags</I>
options. For example, use ``-option SKWEEL -W'' to
have <I>skweel</I> print out statistics. You need to know
the name of the pass to use this flag. Some common
pass names are: <B>SF2C</B>, <B>CPP</B>, <B>SNOOT</B>, <B>FIXFORTRAN</B>, <B>MGEN</B>,
and <B>LD</B>. Phases that might run more than once have
more obscure names, since each pass must be
uniquely named. If you use the verbose option
(-v), you will see the pass name of each pass as it
is executed, followed by the command to run that
pass. See the table in src/baseparsuif/pscc/commands.def
for a complete list.
<B>-yes</B> <I>passname</I>
Force a particular pass to run, overriding other
options. For example, ``pscc f.c -yes SR'' runs
the strength reduction pass, even though <B>-O</B> wasn't
specified. The string <I>passname</I> must be a valid
pass name; see the <B>-option</B> flag for details about
pass names.
<B>-no</B> <I>passname</I>
This is the opposite of the <B>-yes</B> flag. It prevents
a pass from running, even if specified by other
options. For example, ``pscc -O f.c -no REG' runs
the optimizer but skips the register allocation
phase. As with the <B>-yes</B> flag, <I>passname</I> must be a
valid pass name; see the <B>-option</B> flag for details
about pass names.
<B>-automatic</B>
Put Fortran locals on the stack by calling <I>sf2c</I>
with the <B>-a</B> flag. This is the default.
<B>-static</B>
Keep Fortran locals in memory and initialize them
to zero.
<B>-N</B><I>anything</I>
Any flag beginning with upper case ``N'' is passed
through to <I>sf2c</I> unchanged. <I>sf2c</I> uses this to specify
implementation limits for its own internal processing.
See the <I>sf2c</I> documentation.
<B>-checkwarn</B>
This runs <I>checksuif</I> on the output of every pass
that produces a SUIF file. The <I>checksuif</I> program
is given the <B>-warn</B> flag so it will print a warning
about anything illegal that it finds.
<B>-checkfail</B>
This is identical to <B>-checkwarn</B> except that it
gives the <B>-fail</B> switch to <I>checksuif</I> so it will
print an error message and abort the whole compile
if it finds a problem.
<B>-Wall</B> This turns on all warnings again, in case they were
turned off by <B>-w</B>.
</DD>
</DL>

<H2><A NAME="sect4" HREF="#toc4"><B>Environment</B> <B>Variables</B></A></H2>

<P>
<B>SUIFHOME</B><BR>

The top directory in the SUIF file hierarchy.
<B>MACHINE</B><BR>

The type of machine on which the system is running.
The convention used is &lt;architecture&gt;-&lt;vendor&gt;-&lt;OS&gt;,
for example, mips-sgi-irix5, sparc-sunsunos4,
or mips-dec-ultrix.

<DL>

<DT><B>SUIFPATH</B></DT></DT>
<DD>
List of directories to search for SUIF binaries.
The directory names are separated by colons. If
this variable is not specified, <I>pscc</I> defaults to
look in the $<B>SUIFHOME</B>/$<B>MACHINE</B>/bin directory.
<B>TMPDIR</B> Directory where temporary files are stored. The
default value is /tmp. This can also be overridden
with the <B>-t</B> option.
</DD>
</DL>

<H2><A NAME="sect5" HREF="#toc5"><B>History</B></A></H2>

<P>
The <I>pscc</I> program is a mutation of the <I>scc</I> program to contain
parallization features that are being removed from
the basic <I>scc.</I>
<P>

<HR><P>
<A NAME="toc"><B>Table of Contents</B></A><P>
<UL>
<LI><A NAME="toc0" HREF="#sect0">Name</A></LI>
<LI><A NAME="toc1" HREF="#sect1">Synopsis</A></LI>
<LI><A NAME="toc2" HREF="#sect2">Description</A></LI>
<LI><A NAME="toc3" HREF="#sect3">Options</A></LI>
<LI><A NAME="toc4" HREF="#sect4">Environment Variables</A></LI>
<LI><A NAME="toc5" HREF="#sect5">History</A></LI>
</UL>
</BODY></HTML>
